/*
 * Global vars.  Deal with it.
 */

/* OPEN (kernal) filehandle */

FILE *OPENFH;

/* RAM/ROM/Regs */

unsigned char *rom;
unsigned char *ram;

/* CPU registers */

//unsigned int reg_a = 0;
//unsigned int reg_x = 0;
//unsigned int reg_y = 0;
long reg_a = 0;			// Can be signed for intermediate results
long reg_x = 0;
long reg_y = 0;
unsigned int reg_pc = 0;
unsigned int reg_dbr = 0;
unsigned int reg_pbr = 0;
unsigned int reg_sp = 0x01ff;
unsigned char reg_flags = 0;
unsigned char reg_e = 1;
unsigned char reg_d = 0;		// Direct page

/* Opcode matrix */

/* opcode globs are in opglobs.h */

/*
#
# Available memory configurations are:
#
#  lower 3 bits
# 	01	$A000	$D000	$E000
#       --	-----	-----	-----
#	x00	RAM	RAM	RAM
#	001	RAM	ChrROM	RAM
#	101	RAM	I/O	RAM
#	010	RAM	ChrROM	Kernal
#	110	RAM	I/O	Kernal
#	011	BASIC	ChrROM	Kernal
#	111	BASIC	I/O	Kernal
#
*/

#define _RAM_ 0
#define _ROM_ 1
#define _IO_ 2

/*
my @a000 = qw/ram ram ram rom ram ram ram rom/;
my @d000 = qw/ram rom rom rom ram io io io/;
my @e000 = qw/ram ram rom rom ram ram rom rom/;
*/
char a000[8] = {_RAM_, _RAM_, _RAM_, _ROM_, _RAM_, _RAM_, _RAM_, _ROM_};
char d000[8] = {_RAM_, _ROM_, _ROM_, _ROM_, _RAM_, _IO_, _IO_, _IO_};
char e000[8] = {_RAM_, _RAM_, _ROM_, _ROM_, _RAM_, _RAM_, _ROM_, _ROM_};

unsigned char opcode;	// Opcode byte read in
unsigned char mnem;
unsigned char mode;
unsigned long oppc;			// PC of opcode being read in
unsigned char address[3] = {0, 0, 0};	// Physical bytes read in
unsigned long effective_address=0;
unsigned char bytesread[4];		// All bytes read by ParseOp
unsigned char numbytesread;

unsigned char emul=1;			// Emulation mode (1=emulation mode)
unsigned char xflag=1;			// X processor flag
unsigned char mflag=1;			// M processor flag
unsigned char cflag=0;
unsigned char alo=0;			// low byte, .A reg
unsigned char ahi=0;
unsigned char xlo=0;
unsigned char xhi=0;
unsigned char ylo=0;
unsigned char yhi=0;

/* Load/Save stuff */

long loadaddr;
long endloadaddr;

/* Convert to/from petscii flag */

char petsciiflag=1;
